/*
 * This file is a part of KEMET project (Library).
 * 
 * Copyright (C) 2008 MAUPIN Fabrice
 *
 * This library is free software; 
 * you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License 
 * as published by the Free Software Foundation; 
 * either version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with this library; 
 * if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */
package org.kemet.tests.basic;

import java.util.Vector;

import junit.framework.TestCase;

import org.apache.log4j.Logger;
import org.junit.Test;
import org.kemet.impl.grammar.toolbox.ReflexionToolBox;

/**
 * 
 * @author fabricemaupin
 * 
 * <p>
 * <b>Reflexion Tests.</b>
 * </p>
 * 
 * @since 0.1
 */
public class TestReflexion extends TestCase {
	static Logger log = Logger.getLogger("org.kemet.tests");

	/**
	 * <p>
	 * <b>verify if reflexion process is well.</b>
	 * </p>
	 * 
	 * @throws Exception
	 * 
	 * @since 0.1
	 */
	@Test
	public void test1Reflexion() throws Exception {
		// initialize the data tests...
		String[] signList = new String[] { "G1_N29_G37", "M17_O34_I9_X1_G37",
				"G43_D58_N35_N8", "I9_N29_G1_Z8_Y1", "G17_S29_V28_I3",
				"O4_D21_G43_N5", "F32_V31_D21_Aa30", "S29_D58_V28_F18_A2",
				"W11_D21_V28_N2", "D46_G1_M17_Z7_Y5" };

		Vector<Object[]> param = new Vector();
		param.add(new Object[] { String[].class, signList });

		// test if name method or associated value are null
		assertEquals(ReflexionToolBox.execMethod(null, "myClass", param), "");
		assertEquals(ReflexionToolBox.execMethod(null, "myClass", null), "");

		Vector v = new Vector();
		v.add(null);
		
		assertEquals(ReflexionToolBox.execGenericMethod(Class
				.forName("org.kemet.mdc.Cadrat"), "Cadrat", v), null);

		assertEquals(ReflexionToolBox
				.searchMethod(Class.forName("org.kemet.mdc.Cadrat"), "toto",
						"java.util.ArrayList"), false);
	}
}
